/**
 * ideal-postcodes-core - Ideal Postcodes core frontend javascript library
 * @version v0.3.3
 * @link https://ideal-postcodes.co.uk/
 * @license MIT
 */

var __extends=this&&this.__extends||function(t,e){function r(){this.constructor=t}for(var o in e)e.hasOwnProperty(o)&&(t[o]=e[o]);t.prototype=null===e?Object.create(e):(r.prototype=e.prototype,new r)},IdealPostcodes;!function(t){t.API_URL="api.ideal-postcodes.co.uk",t.TLS=!0,t.VERSION="v1",t.DEFAULT_TIMEOUT=1e4,t.STRICT_AUTHORISATION=!1}(IdealPostcodes||(IdealPostcodes={})),window.IdealPostcodes=IdealPostcodes;var IdealPostcodes;!function(t){var e;!function(t){t.now=function(){return Date.now()},t.debounce=function(e,r){function o(){var c=t.now()-u;c>0&&c<r?n=setTimeout(o,r-c):(n=null,a=e.apply(i,s),n||(i=s=null))}void 0===r&&(r=100);var n,s,i,u,a;return function(){return i=this,s=arguments,u=t.now(),n||(n=setTimeout(o,r)),a}},t.extend=function(t){for(var e=[],r=1;r<arguments.length;r++)e[r-1]=arguments[r];for(var o=e.length,n=0;n<o;n++){var s=e[n];for(var i in s)void 0!==s[i]&&(t[i]=s[i])}return t}}(e=t.Utils||(t.Utils={}))}(IdealPostcodes||(IdealPostcodes={}));var IdealPostcodes;!function(t){var e=["id","query","limit","page","post_town","postcode_outward","filter"],r=function(t){return e.map(function(e){return[e,t[e]]}).filter(function(t){return void 0!==t[1]}).map(function(t){return t.join("=")}).join("|")},o=function(){function t(){this.initialiseStore(),this.active=!0}return t.prototype.disable=function(){this.active=!1},t.prototype.enable=function(){this.active=!0},t.prototype.initialiseStore=function(){this.store={postcodeStore:{},addressStore:{},autocompleteStore:{},udprnStore:{},umprnStore:{}}},t.prototype.cacheAddressQuery=function(t,e){if(this.active){var o=r(t);this.store.addressStore[o]=e}},t.prototype.getAddressQuery=function(t){if(this.active){var e=r(t);return this.store.addressStore[e]}},t.prototype.cachePostcodeQuery=function(t,e){if(this.active){var o=r(t);this.store.postcodeStore[o]=e}},t.prototype.getPostcodeQuery=function(t){if(this.active){var e=r(t);return this.store.postcodeStore[e]}},t.prototype.cacheAutocompleteQuery=function(t,e){if(this.active){var o=r(t);this.store.autocompleteStore[o]=e}},t.prototype.getAutocompleteQuery=function(t){if(this.active){var e=r(t);return this.store.autocompleteStore[e]}},t.prototype.cacheUdprnQuery=function(t,e){if(this.active){var o=r(t);this.store.udprnStore[o]=e}},t.prototype.getUdprnQuery=function(t){if(this.active){var e=r(t);return this.store.udprnStore[e]}},t.prototype.cacheUmprnQuery=function(t,e){if(this.active){var o=r(t);this.store.umprnStore[o]=e}},t.prototype.getUmprnQuery=function(t){if(this.active){var e=r(t);return this.store.umprnStore[e]}},t}();t.Cache=o}(IdealPostcodes||(IdealPostcodes={}));var IdealPostcodes;!function(t){var e;!function(t){t.blankRe=/^\s*$/,t.AllowedAuthorizationParameters=["api_key"],t.detectTls=function(t){try{return"http:"!==t.location.protocol}catch(e){return!0}},t.isIE=function(t){var e=t?t:window.navigator;try{var r=e.userAgent.toLowerCase();return r.indexOf("msie")!==-1&&parseInt(r.split("msie")[1])}catch(o){return!1}},t.generateQueryString=function(t){var e=[];for(var r in t)e.push(encodeURIComponent(r)+"="+encodeURIComponent(t[r]));return e.join("&")},t.constructHeaders=function(e){var r={};return r.Authorization=t.constructAuthenticationHeader(e),r},t.deconstructAuthenticationHeader=function(t){var e={};return t?(t.replace("IDEALPOSTCODES ","").trim().split(" ").forEach(function(t){var r=t.split("=");"string"==typeof r[0]&&"string"==typeof r[1]&&(e[r[0]]=r[1].replace(/(^"|"$)/g,""))}),e):e},t.constructAuthenticationHeader=function(e){for(var r=[],o=0;o<t.AllowedAuthorizationParameters.length;o++){var n=t.AllowedAuthorizationParameters[o];void 0!==e[n]&&r.push(n+'="'+e[n]+'"')}return 0===r.length?"":"IDEALPOSTCODES "+r.join(" ")},t.constructQueryString=function(t){var e={};return t.filter&&(e.filter=t.filter.join(",")),t.licensee&&(e.licensee=t.licensee),t.tags&&(e.tags=t.tags.join(",")),e},t.constructAutocompleteQueryString=function(t){var e={};return e.query=t.query,t.limit&&(e.limit=t.limit),t.postcode_outward&&(e.postcode_outward=t.postcode_outward.join(",")),t.post_town&&(e.post_town=t.post_town.join(",")),e},t.constructAddressQueryString=function(t){var e={};return e.query=t.query,e.page=t.page||0,e.limit=t.limit||10,t.postcode_outward&&(e.postcode_outward=t.postcode_outward.join(",")),t.post_town&&(e.post_town=t.post_town.join(",")),e}}(e=t.Transport||(t.Transport={}))}(IdealPostcodes||(IdealPostcodes={}));var IdealPostcodes;!function(t){var e;!function(t){var e=function(t){function e(e){var r=t.call(this)||this;return r.message="Ideal Postcodes Error: "+e.message,r}return __extends(e,t),e}(Error);t.IdealPostcodesError=e;var r=function(t){function e(){return t.call(this,{message:"Unable to parse JSON response"})||this}return __extends(e,t),e}(e);t.JsonParseError=r}(e=t.Errors||(t.Errors={}))}(IdealPostcodes||(IdealPostcodes={}));var IdealPostcodes;!function(t){var e;!function(t){t.parse=function(e){var o=e.status;if(200!==o){switch(o){case 503:return new r}try{return t.parseErrorResponse(JSON.parse(e.responseText),o)}catch(n){return new t.JsonParseError}}},t.parseErrorResponse=function(t,r){var o=t.code,s=t.message;return void 0===o||void 0===s?new n:new e({responseCode:o,status:r,message:s})};var e=function(t){function e(e){var r=t.call(this,e)||this;return e.status&&(r.status=e.status),e.responseCode&&(r.responseCode=e.responseCode),r}return __extends(e,t),e}(t.IdealPostcodesError);t.IdealPostcodesApiError=e;var r=function(t){function e(){return t.call(this,{status:503,message:"Rate Limit Reached. Please wait a while before you retry your request"})||this}return __extends(e,t),e}(e);t.RateLimitError=r;var o=function(t){function e(){return t.call(this,{message:"Request timed out"})||this}return __extends(e,t),e}(e);t.RequestTimeoutError=o;var n=function(t){function e(){return t.call(this,{message:"Unknown AJAX error occurred when accessing API"})||this}return __extends(e,t),e}(e);t.GenericApiError=n}(e=t.Errors||(t.Errors={}))}(IdealPostcodes||(IdealPostcodes={}));var IdealPostcodes;!function(t){var e;!function(e){e.getXhr=function(){try{return new(XMLHttpRequest||ActiveXObject)("MSXML2.XMLHTTP.3.0")}catch(t){return null}},e.xhrRequest=function(r,o){var n=r.url,s=e.generateQueryString(r.queryString);s.length>0&&(n+="?"+s);var i=e.getXhr();i.open(r.method,n,!0);try{for(var u in r.headers)i.setRequestHeader(u,r.headers[u])}catch(a){}var c=setTimeout(function(){i.onreadystatechange=function(){},i.abort(),o(new Error("Request timeout"),null,i)},r.timeout);return i.onreadystatechange=function(){var r;if(4===i.readyState){if(clearTimeout(c),200!==i.status)return o(t.Errors.parse(i),{},i);try{r=e.blankRe.test(i.responseText)?{}:JSON.parse(i.responseText)}catch(n){return o(new Error("parsererror"),null,i)}return o(null,r,i)}},i.send(r.data),i}}(e=t.Transport||(t.Transport={}))}(IdealPostcodes||(IdealPostcodes={}));var IdealPostcodes;!function(t){var e;!function(e){var r=0,o=function(){},n=function(r,o){r.queryString.callback=o;var n=r.headers,s=e.deconstructAuthenticationHeader(n.Authorization);return t.Utils.extend(r.queryString,s),e.generateQueryString(r.queryString)},s=function(t){var e=t.code;return e&&"number"==typeof e?parseInt(String(e).slice(0,3)):500};e.jsonpRequest=function(e,i){r+=1;var u=e.url;if(e.method&&"get"!==e.method.toLowerCase())return i(new Error("Browser is unable to perform non-GET requests"),null,null),null;var a="idpc_"+t.Utils.now()+"_"+r,c=n(e,a);c.length>0&&(u+="?"+c);var l=document.getElementsByTagName("script")[0]||document.head,d=setTimeout(function(){p(),i(new Error("Request timeout"),null,null)},e.timeout),p=function(){h.parentNode&&h.parentNode.removeChild(h),window[a]=o,d&&clearTimeout(d)};window[a]=function(e){p();var r=s(e),o={responseText:e,status:r};return 200!==o.status?i(t.Errors.parseErrorResponse(e,r),null,o):i(null,e,o)};var h=document.createElement("script");return h.src=u,h.type="text/javascript",l.parentNode.insertBefore(h,l),null}}(e=t.Transport||(t.Transport={}))}(IdealPostcodes||(IdealPostcodes={}));var IdealPostcodes;!function(t){var e;!function(e){e.defaultHeaders={Accept:"text/javascript, application/javascript"},e.request=function(r,o){var n={url:r.url,method:r.method||"GET",headers:r.headers||{},queryString:r.queryString||{},timeout:r.timeout||t.DEFAULT_TIMEOUT,data:r.data||null};return t.Utils.extend(n.headers,e.defaultHeaders),e.isIE()&&e.isIE()<10?e.jsonpRequest(n,o):e.xhrRequest(n,o)}}(e=t.Transport||(t.Transport={}))}(IdealPostcodes||(IdealPostcodes={}));var IdealPostcodes;!function(t){var e=t.Utils.extend,r=t.Transport,o=r.constructHeaders,n=r.constructQueryString,s=r.constructAddressQueryString,i=r.constructAutocompleteQueryString,u=function(){function r(e){void 0===e&&(e={});var r=this;this.api_key=e.api_key,this.tls=void 0===e.tls?t.TLS:e.tls,this.version=void 0===e.version?t.VERSION:e.version,this.baseUrl=void 0===e.baseUrl?t.API_URL:e.baseUrl,this.strictAuthorisation=void 0===e.strictAuthorisation?t.STRICT_AUTHORISATION:e.strictAuthorisation,this.cache=new t.Cache;var o=this;this.autocompleteCallback=function(){},this.debouncedAutocomplete=t.Utils.debounce(function(t){r.lookupAutocomplete(t,o.autocompleteCallback)})}return r.prototype.apiUrl=function(){return"http"+(this.tls?"s":"")+"://"+this.baseUrl+"/"+this.version},r.prototype.ping=function(e){t.Transport.request({url:"http"+(this.tls?"s":"")+"://"+this.baseUrl},e)},r.prototype.lookupPostcode=function(e,r){var s=this;e.api_key=this.api_key;var i=o(e),u=n(e),a=this.cache.getPostcodeQuery(u);return a?r(null,a):void t.Transport.request({url:this.apiUrl()+"/postcodes/"+encodeURIComponent(e.postcode),headers:i,queryString:u},function(t,e,o){return t&&4040===t.responseCode?r(null,[],o):t?r(t,null,o):(s.cache.cachePostcodeQuery(u,e.result),r(null,e.result,o))})},r.prototype.lookupAddress=function(r,i){var u=this;r.api_key=this.api_key;var a=o(r),c=n(r);e(c,s(r));var l=this.cache.getAddressQuery(c);return l?i(null,l):void t.Transport.request({url:this.apiUrl()+"/addresses",headers:a,queryString:c},function(t,e,r){return t?i(t,null,r):(u.cache.cacheAddressQuery(c,e.result),i(null,e.result,r))})},r.prototype.lookupAutocomplete=function(r,s){var u=this;r.api_key=this.api_key;var a=o(r),c=n(r);e(c,i(r));var l=this.cache.getAutocompleteQuery(c);return l?s(null,l,null,r):(this.strictAuthorisation||(c.api_key=this.api_key,delete a.Authorization),void t.Transport.request({url:this.apiUrl()+"/autocomplete/addresses",headers:a,queryString:c},function(t,e,o){return t?s(t,null,o,r):(u.cache.cacheAutocompleteQuery(c,e.result),s(null,e.result,o,r))}))},r.prototype.lookupUdprn=function(e,r){var s=this;e.api_key=this.api_key;var i=o(e),u=n(e),a=this.cache.getUdprnQuery(u);return a?r(null,a):void t.Transport.request({url:this.apiUrl()+"/udprn/"+e.id,headers:i,queryString:u},function(t,e,o){return t?r(t,null,o):(s.cache.cacheUdprnQuery(u,e.result),r(null,e.result,o))})},r.prototype.lookupUmprn=function(e,r){var s=this;e.api_key=this.api_key;var i=o(e),u=n(e),a=this.cache.getUmprnQuery(u);return a?r(null,a):void t.Transport.request({url:this.apiUrl()+"/umprn/"+e.id,headers:i,queryString:u},function(t,e,o){return t?r(t,null,o):(s.cache.cacheUmprnQuery(u,e.result),r(null,e.result,o))})},r.prototype.checkKeyUsability=function(e,r){t.Transport.request({url:this.apiUrl()+"/keys/"+this.api_key,queryString:n(e)},function(t,e,o){return t?r(t,null,o):r(null,e.result,o)})},r.prototype.autocompleteAddress=function(t){this.debouncedAutocomplete(t)},r.prototype.registerAutocompleteCallback=function(t){this.autocompleteCallback=t},r}();t.Client=u}(IdealPostcodes||(IdealPostcodes={}));